#ifndef GAME_LOADER_H
#define GAME_LOADER_H

#include "stdincl.h"
#include "story_def.h"

//-----------------------------------------------------------------------------
// Forward declarations
//-----------------------------------------------------------------------------
class Campaign;
class World;
class Camera;
class CammandNode;


class GameLoader 
{

 public:
  static GameLoader* getInstance();

  Error init();
  Error loadCampaign(char* name);
  Error start();
  Error stop();
  Error pause();
  Error resume();
  Error free();

  void nextLevel();
  void previousLevel();

  bool worldCommand(Command* cmd);
  Error loadDebugCampaign(Uint32 campaignID);
  
 private:
  GameLoader ();
  ~GameLoader ();
  Uint32 startTime; //!> start time of the campaign
  static GameLoader* singletonRef;
  bool isPaused;

  Campaign* currentCampaign; //!> the current campaign playing
  
  Campaign* fileToCampaign(char* name);

};

#endif
